<%@ Language=VBScript %>
<% Option Explicit %>
<%
    'Read in the form field values
    Dim iAge, strGender, strE, strA
    Dim strB12, strC, strASP, strAttitude
    
    iAge = Request("Age")
    strGender = Request("Gender")
    strE = Request("E")
    strA = Request("A")
    strB12 = Request("B12")
    strC = Request("C")
    strASP = Request("ASP")
    strAttitude = Request("Attitude")
    
    'We will calculate the user's life expectancy by
    'calculating the nubmer of estimated days they have
    'left to live.  We assume the average man has
    '26,300 days of life, while the average woman has
    '28,500 days of life.
    const iDaysMale = 26300
    const iDaysFemale = 28500
    
    'First, find out how many days the person has currently
    'been alive.  (The users age times 365, since 365 days/year)
    Dim iDaysAlive
    iDaysAlive = iAge * 365
    
    'Now, find out how many days they have left to live by
    'subtracting the expected total days of life by the days
    'of life lived thus far (based upon gender)
    Dim iDaysToLive
    
    If strGender = "Male" then
		iDaysToLive = iDaysMale - iDaysAlive
	Else
		'The user is a woman
		iDaysToLive = iDaysFemale - iDaysAlive
	End If
	
	'Now, add to their expected days to live based on what vitamins
	'they take regularly.  Add 30 days to life expectancy for each
	'vitamin taken regularly
	If strE = "on" then iDaysToLive = iDaysToLive + 30
	If strA = "on" then iDaysToLive = iDaysToLive + 30
	If strB12 = "on" then iDaysToLive = iDaysToLive + 30
	If strC = "on" then iDaysToLive = iDaysToLive + 30
	If strASP = "on" then iDaysToLive = iDaysToLive + 30
    
    'Now, if their attitude is pessimistic, subtract 365 days from
    'their life expectancy.  If it is optimistic, add 365 days.  If
    'it is average, do nothing
    Select Case strAttitude
      Case "Pessimistic":
        iDaysToLive = iDaysToLive - 365
      Case "Optimistic":
        iDaysToLive = iDaysToLive + 365
      Case "Average":
        'Do nothing
    End Select
    
    'We now know how many days we expect the person left to live.
    'If this is less than 0, they are lucky!
    If iDaysToLive < 0 then
      Response.Write "You are lucky to be alive!<BR>"
      Response.Write "You are " & Abs(iDaysToLive) & _
          " days past your life expectancy!"
    Else
      'Display how many days they have left to live
      Response.Write "You should live for another " & _
  	      FormatNumber(iDaysToLive,0) & " days.<BR>"
      
      'Display how many seconds they have left to live
      '(There are 86,400 seconds in a day
      Response.Write "You have " & FormatNumber(iDaysToLive * 86400,0) & _
          " seconds left to live.  Make the most of it!"
    End If
%>