<!--#include virtual="/CODEREUSE/SchemaInfo.Class.asp"-->
<%
    Class ModifyDatabase
      '************** MEMBER VARIABLES *********************
      Private strConnectionString
      Private strUserName
      Private strPassword
      Private strDBAction
      '*****************************************************


      '******************* EVENT HANDLERS ******************
      Private Sub Class_Initialize()
        If UCase(Request.ServerVariables("SCRIPT_NAME")) <> _
                  Ucase(strAction) then
'          Err.Raise vbObjectError + 1234, "ModifyDatabase Class", _
'             "ModifyDatabase can only be instantiated in /CODEREUSE/AdminPageAction.asp"
        End If

        'Read in our action: UPDATE, INSERT, DELETE
        strDBAction = UCase(Request("Action"))

        If strDBAction <> "INSERT" And strDBAction <> "UPDATE" And _
              strDBAction <> "DELETE" And strDBAction <> "UPDATESELECT" then
          'Invalid Action Parameter
          Err.Raise vbObjectError + 1236, "ModifyDatabase Class", _
             "Invalid Action - must be set to INSERT, UPDATE, or DELETE"
        End If
      End Sub
      '*****************************************************


      '****************** GET PROPERTIES *******************
      Public Property Get Action()
         Action = strDBAction
      End Property

      Public Property Get ConnectionString()
         ConnectionString = strConnectionString
      End Property

      Public Property Get UserName()
         UserName = strUserName
      End Property

      Public Property Get Password()
         Password = strPassword
      End Property
      '*****************************************************

      '****************** LET PROPERTIES *******************
      Public Property Let ConnectionString(strConn)
         strConnectionString = strConn
      End Property

      Public Property Let UserName(strUser)
         strUserName = strUser
      End Property

      Public Property Let Password(strPass)
         strPassword = strPass
      End Property
      '*****************************************************


      '********************** METHODS **********************
      Public Sub DeleteRecords()
         'This method deletes one or more records from the database

         'Read in the tablename and determine what request collection we're using
         Dim strTableName, objRequestCol, strIDs
         strTableName = Request("TableName")

         'If tablename doesn't exist, that's really bad.  Throw an error
         If Len(strTableName) = 0 then
             Err.Raise vbObjectError + 1235, "ModifyDatabase Class", _
                  "TableName was not correctly passed in."
         End If

         'Make sure the ID form field exists
         strIDs = Request("ID")
         If Len(strIDs) = 0 then
             'The user did not select a item to delete
             Response.Write "You did not select an item to delete."
             Response.End
         End If


         'Open up a connection to the database
         Dim objConn
         Set objConn = Server.CreateObject("ADODB.Connection")
         objConn.Open strConnectionString, strUserName, strPassword

         Dim strSQL
         strSQL = "DELETE FROM [" & strTableName & "] WHERE "
         strSQL = strSQL & Replace(strIDs, ",", " OR ")

         objConn.Execute strSQL           'Execute the SQL statement

         'Clean up...
         objConn.Close
         Set objConn = Nothing
      End Sub


      Public Sub InsertRecord()
         'This method ads a new record to the database

         'Read in the tablename and determine what request collection we're using
         Dim strTableName         
         strTableName = Request("TableName")

         'If tablename doesn't exist, that's really bad.  Throw an error
         If Len(strTableName) = 0 then
             Err.Raise vbObjectError + 1235, "ModifyDatabase Class", _
                  "TableName was not correctly passed in."
         End If


         'Open up a connection to the database
         Dim objConn
         Set objConn = Server.CreateObject("ADODB.Connection")
         objConn.Open strConnectionString, strUserName, strPassword

         'Retrieve a picture of the database table we're inserting into
         Dim objRS
         Set objRS = Server.CreateObject("ADODB.Recordset")
         objRS.MaxRecords = 1
         objRS.Open "[" & strTableName & "]", objConn, _
                     adOpenForwardOnly, adLockOptimistic, adCmdTable

         objRS.AddNew   'Add a new record

         Dim objField, strFormName
         For Each objField in objRS.Fields
            'If there exists a column in the database table that matches
            'the name of a column passed in from the form with a col_ prefix,
            'set the database column's value to the form element's value
            If Len(Request("col_" & objField.Name)) > 0 then
               objField.Value = Request("col_" & objField.Name)
            End If
         Next

         objRS.Update        'commit the changes

         'Clean up...
         objRS.Close
         Set objRS = Nothing

         objConn.Close
         Set objConn = Nothing
      End Sub


      Public Sub UpdateRecord()
         'This method updates a record in the database

         'Read in the tablename and determine what request collection we're using
         Dim strTableName
         strTableName = Request("TableName")
         
         'If tablename doesn't exist, that's really bad.  Throw an error
         If Len(strTableName) = 0 then
             Err.Raise vbObjectError + 1235, "ModifyDatabase Class", _
                  "TableName was not correctly passed in."
         End If


         'Read in the PrimaryKeyColumns Value
         Dim strPKColumns
         strPKColumns = Request("PrimaryKeyColumns")
         
         'If strPKColumns doesn't exist, that's really bad.  Throw an error
         If Len(strPKColumns) = 0 then
             Err.Raise vbObjectError + 1237, "ModifyDatabase Class", _
                  "PrimaryKeyColumns needed for an UPDATE."
         End If

         'Open up a connection to the database
         Dim objConn
         Set objConn = Server.CreateObject("ADODB.Connection")
         objConn.Open strConnectionString, strUserName, strPassword

         'Retrieve a picture of the database table we're inserting into
         Dim objRS, strSQL
         strSQL = "SELECT * FROM [" & strTableName & "] WHERE " & _
              strPKColumns

         Set objRS = Server.CreateObject("ADODB.Recordset")
         objRS.MaxRecords = 1
         objRS.Open strSQL, objConn, _
                     adOpenForwardOnly, adLockOptimistic

         'Make sure we are on a record
         If objRS.EOF then
            'this is bad...
            Err.Raise vbObjectError + 1380, "ModifyDatabase Class", _
                  "Record to update not found: Failed on - " & strSQL
         End If

         Dim objField, strFormName
         For Each objField in objRS.Fields
            'If there exists a column in the database table that matches
            'the name of a column passed in from the form with a col_ prefix,
            'set the database column's value to the form element's value
            If Len(Request("col_" & objField.Name)) > 0 then
               objField.Value = Request("col_" & objField.Name)
            End If
         Next

         objRS.Update        'commit the changes

         'Clean up...
         objRS.Close
         Set objRS = Nothing

         objConn.Close
         Set objConn = Nothing
      End Sub


      Public Sub UpdateSelect()
        'This function needs to create the Update form
        Dim objAdmin
        Set objAdmin = new AdminPageGenerator
  
        'Read in the tablename and determine what request collection we're using
        Dim strTableName, objRequestCol, strIDs
        strTableName = Request("TableName")

        'If tablename doesn't exist, that's really bad.  Throw an error
        If Len(strTableName) = 0 then
            Err.Raise vbObjectError + 1235, "ModifyDatabase Class", _
                 "TableName was not correctly passed in."
        End If

        'Make sure the ID form field exists
        strIDs = Request("ID")
        If Len(strIDs) = 0 then
            'The user did not select a item to delete
            Response.Write "You did not select an item to delete."
            Response.End
        End If

        'We need to handle foreign key hints
        Dim aHintNames, aHintValues
        aHintNames = split(Request("FKName"), ",")
        aHintValues = split(Request("FKValue"), ",")

        Dim iLoop
        For iLoop = LBound(aHintNames) to UBound(aHintNames)
           objAdmin.ForeignKeyHint Trim(aHintNames(iLoop)), _
                                   Trim(aHintValues(iLoop))
        Next

        'Set the redirect URL if needed
        If Len(Request("Redirect")) > 0 then
          objAdmin.Redirect = Left(Request("Redirect"), _
                     InStr(1, Request("Redirect"), "?") - 1)
        End If

        Response.Write "<HTML><BODY><H1>Edit an Existing " & _
                       UCase(strTableName) & "</H1><BR>" & vbCrLf
        Response.Write objAdmin.UpdateRecordForm(strTableName, strIDs, _
                                                 strConnectionString, _
                                                 strUserName, strPassword)
        Response.Write "</BODY></HTML>"
      End Sub
      '*****************************************************  
  End Class
%>